<template>
		<el-dialog

				class="dialog-update-permission"
				title="Update Permissions Of Role"
				:visible="dialogvisible"
				append-to-body
				@close="$emit('update:dialogvisible', false)">

			<el-table :data="permissionList" empty-text="There are no any permissions." v-loading="loading">
				<el-table-column fixed prop="display_name" label="Permissions"  min-width="150"></el-table-column>
				<el-table-column label="Roles" header-align="center">
					<el-table-column
							min-width="150"
							:label="detail.name">
						<template slot-scope="scope">
							<div class="text-center">
								<el-checkbox
                                    v-model="listChecked[scope.row.id]"
                                    @change="checkBoxHandler(scope.row.id, listChecked[scope.row.id])"
                                    @keyup.enter.native="save"
								></el-checkbox>
							</div>
						</template>
					</el-table-column>
					<el-table-column
							v-if="role.id != detail.id"
							v-for="role in roles"
                            :key="role.id"
							class-name="disable"
							min-width="150"
							:label="role.name">
						<template slot-scope="scope">
							<div class="text-center">
								<el-checkbox v-if="scope.row.id != 'all'"
                                    text-color="#000"
                                    :value = "isChecked(scope.row.id, role.permissions)"
								>
								</el-checkbox>
							</div>
						</template>

					</el-table-column>
				</el-table-column>
			</el-table>

			<div class="text-right">
				<el-button
						icon="mdi mdi-content-save-outline "
						type="primary"
						@click="save"
						class="mt-30"
				> Save changes
				</el-button>
			</div>
		</el-dialog>

</template>

<script>
    import {permission as permissionAPI, role as roleAPI} from '~/services/apis/index'
    export default {
        props: [ 'dialogvisible', 'detail', 'permissions', 'selectedPermissions', 'roles'],
        data() {
            return {
                checkAll: null,
				listChecked:{},
                loading: false,
                permissionList: [],
                numCheck: 0
			}
        },
        methods: {
            initListCheckbox(){
                this.listChecked = [];
                this.permissionList = [...this.permissions, {display_name: '', id: 'all'}]
                this.permissions.map((item,index) => {
                    this.listChecked[item.id] = false;
                });
                // this.loading = true;
                // this.forceChangeToReRenderTable();
            },

            initListChecked(){
                this.numCheck = 0;
                this.listChecked['all'] = false;
                this.detail.permissions.map((item,index) => {
                    this.listChecked[item.id] = true;
                    this.numCheck += 1;
                    if (this.numCheck == this.permissions.length) {
                        this.listChecked['all'] = true;
                    }
                });
            },

			isChecked(id, listPermission){
                if(!listPermission || listPermission.length == 0) return false;

                for(let i = 0; i < listPermission.length; i ++){
                    if(id == listPermission[i].id)
                        return true;
				}
				return false;
            },

            checkBoxHandler(id, value) {
                if (id == 'all') {
                    if (value == true) {
                        this.numCheck = this.permissions.length;
                        this.permissionList.map(item => {
                            this.listChecked[item.id] = true;
                        })
                    } else {
                        this.numCheck = 0;
                        this.permissionList.map(item => {
                            this.listChecked[item.id] = false;
                        })
                    }
                } else {
                    if (value == true) {
                        this.numCheck += 1;
                        if (this.numCheck == this.permissions.length) {
                            this.listChecked['all'] = true;
                        }
                    } else {
                        this.numCheck -= 1;
                        this.listChecked['all'] = false;
                    }
                }
				this.forceChangeToReRenderTable();
            },

			forceChangeToReRenderTable(){
                let key = (new Date()).getTime();
                this.permissionList.push({id: key});
                this.permissionList.splice(-1,1);
                this.loading = false;
			},

            save(){
                this.loading = true;
                let checkedId = [];
                for (var key in this.listChecked) {
                    if (key != 'all') {
                        if (this.listChecked.hasOwnProperty(key)) {
                        if(this.listChecked[key])
                        checkedId.push(key);
                        }
                    }
                }
                let data = {
                    permissions_id: checkedId
                };
                roleAPI.updateRole(this.$route.params.id, data)
				.then((res) => {
					/*eslint-disable*/
					this.$notify({
						title: "Success",
						message: "Update permissions successfully!",
						type: "success"
					});
					this.detail.permissions = res.data.data.permissions;
					this.$emit('update:dialogvisible', false);
					this.loading = false;
				})
				.catch((err) => {
					this.$notify({
						title: "Error",
						message: "Update permissions failed!",
						type: "error"
					});
					this.loading = false;
				})
            }
        },

        watch: {
            permissions: function () {
                if(this.permissions.length > 0){
                    this.initListCheckbox();
                    this.initListChecked();
				}
            },
            dialogvisible: function () {
                // this.loading = true;
                if(this.permissions.length > 0){
                    this.initListCheckbox();
                    this.initListChecked();
				}
            }
        },

    }
</script>

<style lang="scss">
 .dialog-update-permission {
	 .el-dialog{
		 max-width: 90%;
		 width: max-content;

		 .el-checkbox__inner{
			 width: 20px;
			 height: 20px;
			 &::after{
				 margin-left: 2px;
				 width: 5px;
				 height: 11px;
			 }
		 }

		 .el-table__row{
			 &.current-row{
				 td{
					 background: #e1eaf8 !important;
				 }
			 }
			 &.hover-row{
				 td{
					 background: #eff4fc !important;
				 }
			 }
		 }
		 td.disable{
			 background: #f6f6f6;
			 .el-checkbox__input {
				 .el-checkbox__inner{
					 background-color: transparent;
					 &:hover{
						 border-color: #dcdfe6;
					 }
					 &:focus{
						 border-color: #dcdfe6;
					 }

				 }
				 cursor: initial;
				 &.is-focus{
					 .el-checkbox__inner {
						 border-color: #dcdfe6;
					 }

				 }
				 &.is-checked .el-checkbox__inner {
					 background-color: #c4c4c4;
					 border-color: #dcdfe6;
				 }
			 }
		 }
	 }
 }
</style>
